SystemOrganization addCategory: #'TADP-The-Blob'!

Object subclass: #BlendedClassFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-The-Blob'!

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/3/2013 16:20'!
createClass: className data: unaSeparatedClass
| claseNueva |

claseNueva := Object subclass: className 
instanceVariableNames: unaSeparatedClass getAttributesAsString
classVariableNames: ''
poolDictionaries: ''
category: 'TADP-The-Blob'.

unaSeparatedClass getMethods do: [:metodo | claseNueva compile: (metodo getSource)]
! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 19:58'!
findAttributes: unaClase

	^(unaClase instVarNames) asSet

	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/2/2013 23:20'!
findMethodAttributes: unMetodo withClassAttributes: atributos 
| methodAttributes |

	methodAttributes := Set new.
	
	atributos do: [:unAtributo | (unMetodo usesInstVarNamed: unAtributo) ifTrue: [methodAttributes add: unAtributo]].
	
	^methodAttributes

	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 18:10'!
findMethods: unaClase

	^(unaClase methodDictionary) asSet

	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/3/2013 14:17'!
newClassesQuantity: unaClase

	^(self separateClass: unaClase) size - 1
		

	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/3/2013 14:05'!
separateClass: unaClase
| metodos clasesSeparadas atributos atributosCoincidentes atributosDeMetodo cantClases clasesAFusionar primeraVuelta |

	cantClases := 0.
	primeraVuelta := 1.
	metodos := self findMethods: unaClase.
	atributos := self findAttributes: unaClase.
	clasesSeparadas := OrderedCollection new.
	
	metodos do: [:unMetodo | 
		atributosDeMetodo :=(self findMethodAttributes: unMetodo withClassAttributes: atributos).
		(primeraVuelta = 1) ifTrue: [
			clasesSeparadas add: SeparatedClass new.
			clasesSeparadas last setAttributes: atributosDeMetodo.
			clasesSeparadas last getMethods add: unMetodo.
			(atributosDeMetodo size = 0) ifFalse: [primeraVuelta := 0]]
		ifFalse:[
			clasesSeparadas do: [:clase |
					atributosCoincidentes := (atributosDeMetodo intersection: clase getAttributes). 			
					(atributosCoincidentes size > 0) ifTrue: [
						clase setAttributes: (clase getAttributes union: atributosDeMetodo).
						clase getMethods add: unMetodo.
						cantClases := cantClases + 1]].
			(atributosDeMetodo size = 0) ifTrue: [
				clasesSeparadas first getMethods add: unMetodo.
				cantClases := cantClases + 1].
			"Esta parte se fija si el metodo no fue agregado, y entonces agrega una nueva clase para agregarlo;
			o se fija si fue agregado a ms de una clase, y entonces fusiona las clases."
			(cantClases = 0) ifTrue: [
				clasesSeparadas add: SeparatedClass new.
				clasesSeparadas last setAttributes: atributosDeMetodo.
				clasesSeparadas last getMethods add: unMetodo.] 
			ifFalse: [(cantClases > 1) ifTrue: [
				clasesAFusionar := clasesSeparadas select: [:clase | clase getMethods includes: unMetodo].
				clasesSeparadas do: [:clase | clasesSeparadas remove: clase].
				clasesSeparadas add: SeparatedClass new.
				clasesAFusionar do: [:clase | 				
						clasesSeparadas last setAttributes: (clasesSeparadas last getAttributes union: clase getAttributes).
						clasesSeparadas last setMethods: (clasesSeparadas last getMethods union: clase getMethods).]]].
			cantClases := 0]].
		
	^clasesSeparadas! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/3/2013 16:05'!
separateClassesFrom: unaClase name1: nombre1 
| separatedClasses nombreOriginal |

	((self newClassesQuantity: unaClase) = 1) ifFalse: [^'El numero de nombres dados es incorrecto, ejecutar newClassesQuantity:'].

	separatedClasses := self separateClass: unaClase.
	nombreOriginal := unaClase name.
	unaClase removeFromSystem.
	
	self createClass: nombreOriginal data: separatedClasses first. 
	self createClass: nombre1 data: separatedClasses second. 
	
	^'La clase fue dividida en 2'
	
	
	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/3/2013 15:12'!
separateClassesFrom: unaClase name1: nombre1 name2: nombre2
| separatedClasses nombreOriginal |

	((self newClassesQuantity: unaClase) = 2) ifFalse: [^'El numero de nombres dados es incorrecto, ejecutar newClassesQuantity:'].

	separatedClasses := self separateClass: unaClase.
	nombreOriginal := unaClase name.
	unaClase removeFromSystem.
	
	self createClass: nombreOriginal data: separatedClasses first. 
	self createClass: nombre1 data: separatedClasses second. 
	self createClass: nombre2 data: separatedClasses third. 
	
	^'La clase fue dividida en 3'
	
	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/3/2013 15:12'!
separateClassesFrom: unaClase name1: nombre1 name2: nombre2 name3: nombre3
| separatedClasses nombreOriginal |

	((self newClassesQuantity: unaClase) = 3) ifFalse: [^'El numero de nombres dados es incorrecto, ejecutar newClassesQuantity:'].

	separatedClasses := self separateClass: unaClase.
	nombreOriginal := unaClase name.
	unaClase removeFromSystem.
	
	self createClass: nombreOriginal data: separatedClasses first. 
	self createClass: nombre1 data: separatedClasses second. 
	self createClass: nombre2 data: separatedClasses third. 
	self createClass: nombre3 data: separatedClasses last. 
	
	^'La clase fue dividida en 4'! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/3/2013 14:19'!
verifyClass: unaClase
		
	((self newClassesQuantity: unaClase) >  0) 
		ifTrue: [^'La clase puede separarse.'] 
		ifFalse: [^'La clase no puede separarse.']

	! !

Object subclass: #SeparatedClass
	instanceVariableNames: 'attributes methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-The-Blob'!

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 17:57'!
getAttributes

	^attributes! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/3/2013 15:37'!
getAttributesAsString
| stringDeAtributos |

	stringDeAtributos := String new.
	self getAttributes do: [:atributo | stringDeAtributos := stringDeAtributos , ' ' , atributo].
	^stringDeAtributos! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 17:57'!
getMethods

	^methods! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/2/2013 23:51'!
initialize 

	super initialize.
	self setMethods: Set new.
	self setAttributes: Set new.
	! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 17:35'!
setAttributes: coleccionDeAtributos

	attributes := coleccionDeAtributos ! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 17:36'!
setMethods: coleccionDeMetodos

	methods := coleccionDeMetodos ! !
